# SedTrace.jl
*A package for generating and running reactive-transport models of marine sediment diagenetic specializing in trace elements and isotopes.*

## Package Introduction
 SedTrace is a modelling framework that automates the generation of Julia code for diagenetic models and provides high-performance computing tools to assist model simulation, only requiring the user to supply information based on a Microsoft Excel input file. SedTrace specializes in modelling TEIs, and can accommodate a wide range of custom pH and speciation modelling choices. The design principle is to give as much control to the user as possible when creating the model, such that SedTrace is only meant to help converting user ideas to code rather than making model decisions for the user.

The [User Guide](@ref) provides a tutorial explaining how to get started using SedTrace.

Some examples of generating diagenetic modles using SedTrace can be found on the [Examples](@ref) page.

Details of the model description can be found in our paper Du et al., (2022).
