module Param
using SedTrace: fvcf, fvcf_bc
using Parameters, LinearAlgebra, SpecialFunctions
include(
    "c:\\Users\\Jianghui\\.julia\\dev\\SedTrace\\examples\\OregonNd\\parm.OregonNd.jl",
)

#---------------------------------------------------------------
# assemble parameter struct
#---------------------------------------------------------------
@with_kw mutable struct ParamStruct{T}
    MnO2ID::StepRange{Int64,Int64} = MnO2ID
    FeOOHID::StepRange{Int64,Int64} = FeOOHID
    POCID::StepRange{Int64,Int64} = POCID
    FeSID::StepRange{Int64,Int64} = FeSID
    FeS2ID::StepRange{Int64,Int64} = FeS2ID
    CaCO3ID::StepRange{Int64,Int64} = CaCO3ID
    AgeID::StepRange{Int64,Int64} = AgeID
    BSiID::StepRange{Int64,Int64} = BSiID
    NdnrPO4ID::StepRange{Int64,Int64} = NdnrPO4ID
    NdrPO4ID::StepRange{Int64,Int64} = NdrPO4ID
    SurfMn_NdnrID::StepRange{Int64,Int64} = SurfMn_NdnrID
    SurfMn_NdrID::StepRange{Int64,Int64} = SurfMn_NdrID
    SurfFe_NdnrID::StepRange{Int64,Int64} = SurfFe_NdnrID
    SurfFe_NdrID::StepRange{Int64,Int64} = SurfFe_NdrID
    IlliteID::StepRange{Int64,Int64} = IlliteID
    BasaltID::StepRange{Int64,Int64} = BasaltID
    O2ID::StepRange{Int64,Int64} = O2ID
    NO3ID::StepRange{Int64,Int64} = NO3ID
    TMnID::StepRange{Int64,Int64} = TMnID
    TFeID::StepRange{Int64,Int64} = TFeID
    CH4ID::StepRange{Int64,Int64} = CH4ID
    NO2ID::StepRange{Int64,Int64} = NO2ID
    CaID::StepRange{Int64,Int64} = CaID
    AlID::StepRange{Int64,Int64} = AlID
    TNH4ID::StepRange{Int64,Int64} = TNH4ID
    SO4ID::StepRange{Int64,Int64} = SO4ID
    TNdnrID::StepRange{Int64,Int64} = TNdnrID
    TNdrID::StepRange{Int64,Int64} = TNdrID
    TH4SiO4ID::StepRange{Int64,Int64} = TH4SiO4ID
    TCO2ID::StepRange{Int64,Int64} = TCO2ID
    TH2SID::StepRange{Int64,Int64} = TH2SID
    TH3BO3ID::StepRange{Int64,Int64} = TH3BO3ID
    TH3PO4ID::StepRange{Int64,Int64} = TH3PO4ID
    HID::StepRange{Int64,Int64} = HID
    AmMnO2::Tridiagonal{T,Vector{T}} = AmMnO2
    AmFeOOH::Tridiagonal{T,Vector{T}} = AmFeOOH
    AmPOC::Tridiagonal{T,Vector{T}} = AmPOC
    AmFeS::Tridiagonal{T,Vector{T}} = AmFeS
    AmFeS2::Tridiagonal{T,Vector{T}} = AmFeS2
    AmCaCO3::Tridiagonal{T,Vector{T}} = AmCaCO3
    AmAge::Tridiagonal{T,Vector{T}} = AmAge
    AmBSi::Tridiagonal{T,Vector{T}} = AmBSi
    AmNdnrPO4::Tridiagonal{T,Vector{T}} = AmNdnrPO4
    AmNdrPO4::Tridiagonal{T,Vector{T}} = AmNdrPO4
    AmSurfMn_Ndnr::Tridiagonal{T,Vector{T}} = AmSurfMn_Ndnr
    AmSurfMn_Ndr::Tridiagonal{T,Vector{T}} = AmSurfMn_Ndr
    AmSurfFe_Ndnr::Tridiagonal{T,Vector{T}} = AmSurfFe_Ndnr
    AmSurfFe_Ndr::Tridiagonal{T,Vector{T}} = AmSurfFe_Ndr
    AmIllite::Tridiagonal{T,Vector{T}} = AmIllite
    AmBasalt::Tridiagonal{T,Vector{T}} = AmBasalt
    AmO2::Tridiagonal{T,Vector{T}} = AmO2
    AmNO3::Tridiagonal{T,Vector{T}} = AmNO3
    AmCH4::Tridiagonal{T,Vector{T}} = AmCH4
    AmNO2::Tridiagonal{T,Vector{T}} = AmNO2
    AmCa::Tridiagonal{T,Vector{T}} = AmCa
    AmSO4::Tridiagonal{T,Vector{T}} = AmSO4
    AmH4SiO4::Tridiagonal{T,Vector{T}} = AmH4SiO4
    AmH3SiO4::Tridiagonal{T,Vector{T}} = AmH3SiO4
    AmHCO3::Tridiagonal{T,Vector{T}} = AmHCO3
    AmCO3::Tridiagonal{T,Vector{T}} = AmCO3
    AmCO2::Tridiagonal{T,Vector{T}} = AmCO2
    AmH2S::Tridiagonal{T,Vector{T}} = AmH2S
    AmHS::Tridiagonal{T,Vector{T}} = AmHS
    AmH3BO3::Tridiagonal{T,Vector{T}} = AmH3BO3
    AmH4BO4::Tridiagonal{T,Vector{T}} = AmH4BO4
    AmH3PO4::Tridiagonal{T,Vector{T}} = AmH3PO4
    AmH2PO4::Tridiagonal{T,Vector{T}} = AmH2PO4
    AmHPO4::Tridiagonal{T,Vector{T}} = AmHPO4
    AmPO4::Tridiagonal{T,Vector{T}} = AmPO4
    AmH::Tridiagonal{T,Vector{T}} = AmH
    AmOH::Tridiagonal{T,Vector{T}} = AmOH
    AmTMn_dis::Tridiagonal{T,Vector{T}} = AmTMn_dis
    AmTMn_ads::Tridiagonal{T,Vector{T}} = AmTMn_ads
    AmTFe_dis::Tridiagonal{T,Vector{T}} = AmTFe_dis
    AmTFe_ads::Tridiagonal{T,Vector{T}} = AmTFe_ads
    AmAl_dis::Tridiagonal{T,Vector{T}} = AmAl_dis
    AmTNH4_dis::Tridiagonal{T,Vector{T}} = AmTNH4_dis
    AmTNH4_ads::Tridiagonal{T,Vector{T}} = AmTNH4_ads
    AmTNdnr_dis::Tridiagonal{T,Vector{T}} = AmTNdnr_dis
    AmTNdnr_ads::Tridiagonal{T,Vector{T}} = AmTNdnr_ads
    AmTNdr_dis::Tridiagonal{T,Vector{T}} = AmTNdr_dis
    AmTNdr_ads::Tridiagonal{T,Vector{T}} = AmTNdr_ads
    BcAmMnO2::Vector{T} = BcAmMnO2
    BcCmMnO2::Vector{T} = BcCmMnO2
    BcAmFeOOH::Vector{T} = BcAmFeOOH
    BcCmFeOOH::Vector{T} = BcCmFeOOH
    BcAmPOC::Vector{T} = BcAmPOC
    BcCmPOC::Vector{T} = BcCmPOC
    BcAmFeS::Vector{T} = BcAmFeS
    BcCmFeS::Vector{T} = BcCmFeS
    BcAmFeS2::Vector{T} = BcAmFeS2
    BcCmFeS2::Vector{T} = BcCmFeS2
    BcAmCaCO3::Vector{T} = BcAmCaCO3
    BcCmCaCO3::Vector{T} = BcCmCaCO3
    BcAmAge::Vector{T} = BcAmAge
    BcCmAge::Vector{T} = BcCmAge
    BcAmBSi::Vector{T} = BcAmBSi
    BcCmBSi::Vector{T} = BcCmBSi
    BcAmNdnrPO4::Vector{T} = BcAmNdnrPO4
    BcCmNdnrPO4::Vector{T} = BcCmNdnrPO4
    BcAmNdrPO4::Vector{T} = BcAmNdrPO4
    BcCmNdrPO4::Vector{T} = BcCmNdrPO4
    BcAmSurfMn_Ndnr::Vector{T} = BcAmSurfMn_Ndnr
    BcCmSurfMn_Ndnr::Vector{T} = BcCmSurfMn_Ndnr
    BcAmSurfMn_Ndr::Vector{T} = BcAmSurfMn_Ndr
    BcCmSurfMn_Ndr::Vector{T} = BcCmSurfMn_Ndr
    BcAmSurfFe_Ndnr::Vector{T} = BcAmSurfFe_Ndnr
    BcCmSurfFe_Ndnr::Vector{T} = BcCmSurfFe_Ndnr
    BcAmSurfFe_Ndr::Vector{T} = BcAmSurfFe_Ndr
    BcCmSurfFe_Ndr::Vector{T} = BcCmSurfFe_Ndr
    BcAmIllite::Vector{T} = BcAmIllite
    BcCmIllite::Vector{T} = BcCmIllite
    BcAmBasalt::Vector{T} = BcAmBasalt
    BcCmBasalt::Vector{T} = BcCmBasalt
    BcAmO2::Vector{T} = BcAmO2
    BcCmO2::Vector{T} = BcCmO2
    BcAmNO3::Vector{T} = BcAmNO3
    BcCmNO3::Vector{T} = BcCmNO3
    BcAmCH4::Vector{T} = BcAmCH4
    BcCmCH4::Vector{T} = BcCmCH4
    BcAmNO2::Vector{T} = BcAmNO2
    BcCmNO2::Vector{T} = BcCmNO2
    BcAmCa::Vector{T} = BcAmCa
    BcCmCa::Vector{T} = BcCmCa
    BcAmSO4::Vector{T} = BcAmSO4
    BcCmSO4::Vector{T} = BcCmSO4
    Ngrid::Int64 = Ngrid
    BcAmH4SiO4::Vector{T} = BcAmH4SiO4
    BcCmH4SiO4::Vector{T} = BcCmH4SiO4
    BcAmH3SiO4::Vector{T} = BcAmH3SiO4
    BcCmH3SiO4::Vector{T} = BcCmH3SiO4
    BcAmHCO3::Vector{T} = BcAmHCO3
    BcCmHCO3::Vector{T} = BcCmHCO3
    BcAmCO3::Vector{T} = BcAmCO3
    BcCmCO3::Vector{T} = BcCmCO3
    BcAmCO2::Vector{T} = BcAmCO2
    BcCmCO2::Vector{T} = BcCmCO2
    BcAmH2S::Vector{T} = BcAmH2S
    BcCmH2S::Vector{T} = BcCmH2S
    BcAmHS::Vector{T} = BcAmHS
    BcCmHS::Vector{T} = BcCmHS
    BcAmH3BO3::Vector{T} = BcAmH3BO3
    BcCmH3BO3::Vector{T} = BcCmH3BO3
    BcAmH4BO4::Vector{T} = BcAmH4BO4
    BcCmH4BO4::Vector{T} = BcCmH4BO4
    BcAmH3PO4::Vector{T} = BcAmH3PO4
    BcCmH3PO4::Vector{T} = BcCmH3PO4
    BcAmH2PO4::Vector{T} = BcAmH2PO4
    BcCmH2PO4::Vector{T} = BcCmH2PO4
    BcAmHPO4::Vector{T} = BcAmHPO4
    BcCmHPO4::Vector{T} = BcCmHPO4
    BcAmPO4::Vector{T} = BcAmPO4
    BcCmPO4::Vector{T} = BcCmPO4
    BcAmH::Vector{T} = BcAmH
    BcCmH::Vector{T} = BcCmH
    BcAmOH::Vector{T} = BcAmOH
    BcCmOH::Vector{T} = BcCmOH
    BcAmTMn_dis::Vector{T} = BcAmTMn_dis
    BcCmTMn_dis::Vector{T} = BcCmTMn_dis
    BcAmTMn_ads::Vector{T} = BcAmTMn_ads
    BcCmTMn_ads::Vector{T} = BcCmTMn_ads
    BcAmTFe_dis::Vector{T} = BcAmTFe_dis
    BcCmTFe_dis::Vector{T} = BcCmTFe_dis
    BcAmTFe_ads::Vector{T} = BcAmTFe_ads
    BcCmTFe_ads::Vector{T} = BcCmTFe_ads
    BcAmAl_dis::Vector{T} = BcAmAl_dis
    BcCmAl_dis::Vector{T} = BcCmAl_dis
    BcAmTNH4_dis::Vector{T} = BcAmTNH4_dis
    BcCmTNH4_dis::Vector{T} = BcCmTNH4_dis
    BcAmTNH4_ads::Vector{T} = BcAmTNH4_ads
    BcCmTNH4_ads::Vector{T} = BcCmTNH4_ads
    BcAmTNdnr_dis::Vector{T} = BcAmTNdnr_dis
    BcCmTNdnr_dis::Vector{T} = BcCmTNdnr_dis
    BcAmTNdnr_ads::Vector{T} = BcAmTNdnr_ads
    BcCmTNdnr_ads::Vector{T} = BcCmTNdnr_ads
    BcAmTNdr_dis::Vector{T} = BcAmTNdr_dis
    BcCmTNdr_dis::Vector{T} = BcCmTNdr_dis
    BcAmTNdr_ads::Vector{T} = BcAmTNdr_ads
    BcCmTNdr_ads::Vector{T} = BcCmTNdr_ads
    alpha::Vector{T} = alpha
    O2BW::T = O2BW
    NO3BW::T = NO3BW
    CH4BW::T = CH4BW
    NO2BW::T = NO2BW
    CaBW::T = CaBW
    SO4BW::T = SO4BW
    H4SiO4BW::T = H4SiO4BW
    H3SiO4BW::T = H3SiO4BW
    HCO3BW::T = HCO3BW
    CO3BW::T = CO3BW
    CO2BW::T = CO2BW
    H2SBW::T = H2SBW
    HSBW::T = HSBW
    H3BO3BW::T = H3BO3BW
    H4BO4BW::T = H4BO4BW
    H3PO4BW::T = H3PO4BW
    H2PO4BW::T = H2PO4BW
    HPO4BW::T = HPO4BW
    PO4BW::T = PO4BW
    HBW::T = HBW
    OHBW::T = OHBW
    TMn_dis0::T = TMn_dis0
    TFe_dis0::T = TFe_dis0
    Al_disBW::T = Al_disBW
    TNH4_dis0::T = TNH4_dis0
    TNdnr_dis0::T = TNdnr_dis0
    TNdr_dis0::T = TNdr_dis0
    dstopw::Vector{T} = dstopw
    KH4SiO4::T = KH4SiO4
    KCO2::T = KCO2
    KHCO3::T = KHCO3
    KH2S::T = KH2S
    KH3BO3::T = KH3BO3
    KH3PO4::T = KH3PO4
    KH2PO4::T = KH2PO4
    KHPO4::T = KHPO4
    KH2O::T = KH2O
    KMn_ads_Fe::T = KMn_ads_Fe
    KMn_ads_Mn::T = KMn_ads_Mn
    Cl::T = Cl
    KFe_ads_Fe::T = KFe_ads_Fe
    KFe_ads_Mn::T = KFe_ads_Mn
    KNH4_ads::T = KNH4_ads
    KNd_ads_Fe::T = KNd_ads_Fe
    KNd_ads_Mn::T = KNd_ads_Mn
    KspFeS::T = KspFeS
    KspCaCO3_dis::T = KspCaCO3_dis
    H4SiO4_dis_sat::T = H4SiO4_dis_sat
    KspNdPO4::T = KspNdPO4
    KspBasalt::T = KspBasalt
    rNC::T = rNC
    rPC::T = rPC
    pwtods::Vector{T} = pwtods
    rAlSi::T = rAlSi
    rNdnrSi_lith::T = rNdnrSi_lith
    rNdrSi_lith::T = rNdrSi_lith
    KO2::T = KO2
    nu::T = nu
    a::T = a
    KNO2::T = KNO2
    KNO3::T = KNO3
    KMnO2::T = KMnO2
    KFeOOH::T = KFeOOH
    KSO4::T = KSO4
    kO2NO2::T = kO2NO2
    kO2NH4::T = kO2NH4
    kO2Mn::T = kO2Mn
    kO2Mn_ads::T = kO2Mn_ads
    kO2Fe::T = kO2Fe
    kO2Fe_ads::T = kO2Fe_ads
    kO2H2S::T = kO2H2S
    kO2FeS::T = kO2FeS
    kO2CH4::T = kO2CH4
    kNO2NH4::T = kNO2NH4
    kAOM::T = kAOM
    KAOM::T = KAOM
    kMnO2Fe::T = kMnO2Fe
    kMnO2H2S::T = kMnO2H2S
    kFeOOHH2S::T = kFeOOHH2S
    kFeSH2S::T = kFeSH2S
    kFeSdis::T = kFeSdis
    kFeSpre::T = kFeSpre
    kCaCO3dis0::T = kCaCO3dis0
    kCaCO3dis1::T = kCaCO3dis1
    nCaCO3dis::T = nCaCO3dis
    kBSi_dis::T = kBSi_dis
    DNdMn::T = DNdMn
    DNdFe::T = DNdFe
    kNdPO4_pre::T = kNdPO4_pre
    kIllite::T = kIllite
    KspIllite::T = KspIllite
    kBasalt::T = kBasalt
    a_lith0::T = a_lith0
end
end
